For the impatient: [report][cpo_new-issue], confirm, claim,
[fork][gh_chiliproject], [branch][cpo_contribute-code-branch],
[write][cpo_code-standards], [test][cpo_code-review], push.

The short version:

* Make sure the issue you are working on is reported and confirmed, add a note
  to the issue to claim your intention to work on it.
* Fork [ChiliProject on GitHub][gh_chiliproject]
* Create a new branch from `master` with a descriptive name prefixed by the
  issue ID (Example: `123-change_background_from_black_to_blue`).
* Make changes according to our [Code Standards][cpo_code-standards].
    1. Be sure to include tests as necessary.
    1. Make sure to not break existing tests.
    1. Please try to make sure your code is going to pass a [Code
       Review][cpo_code-review] prior to submitting the patch. If in doubt, just ask.
* Either upload your branch to GitHub and send a pull request to the
  ChiliProject repository, or attach a patch to the issue on ChiliProject. If
  you send a pull request on GitHub, remember to link to the pull request in the
  issue you create on ChiliProject and to link to the issue on ChiliProject in
  the pull request on GitHub.
* Make sure you watch the corresponding issue in case any discussion arises or
  improvements are needed.

The long version is on the [Contribute Code][cpo_contribute-code] page.


[cpo_new-issue]: https://www.chiliproject.org/projects/chiliproject/issues/new
[cpo_contribute-code-branch]: https://www.chiliproject.org/projects/chiliproject/wiki/Contribute_Code#Branch
[cpo_contribute-code]: https://www.chiliproject.org/projects/chiliproject/wiki/Contribute_Code
[cpo_code-standards]: https://www.chiliproject.org/projects/chiliproject/wiki/Code_Standards
[cpo_code-review]: https://www.chiliproject.org/projects/chiliproject/wiki/Code_Review
[gh_chiliproject]: https://github.com/chiliproject/chiliproject
